Index: /trunk/src/sys/arch/mips/mips/mipsX_subr.S
===================================================================
--- /trunk/src/sys/arch/mips/mips/mipsX_subr.S	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/mipsX_subr.S	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: mipsX_subr.S,v 1.26.36.1.2.31 2010/04/28 03:14:45 matt Exp $	*/
+/*	$NetBSD: mipsX_subr.S,v 1.26.36.1.2.44 2011/05/28 02:20:13 matt Exp $	*/
 
 /*
@@ -120,4 +120,5 @@
 #include "opt_kgdb.h"
 #include "opt_mips3_wired.h"
+#include "opt_multiprocessor.h"
 #include "opt_vmswap.h"
 
@@ -126,5 +127,5 @@
 #include <mips/asm.h>
 #include <mips/cpuregs.h>
-#if defined(MIPS3) && !defined(MIPS3_5900)
+#if defined(MIPS3)
 #include <mips/cache_r4k.h>
 #endif
@@ -148,14 +149,10 @@
 #endif
 
-/*
- * XXX MIPS3_5900 is still "special" for much of this code.
- */
-
 #if MIPS1
 #error This file can not be compiled with MIPS1 defined
 #endif
 
-#if MIPS3 + MIPS32 + MIPS64 != 1
-# error  Only one of MIPS{3,32,64} can be defined
+#if (MIPS3 + MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) != 1
+# error  Only one of MIPS{3,32,32R2,64,64R2} can be defined
 #endif
 
@@ -163,21 +160,15 @@
  * Use 64bit cp0 instructions?
  */
-#if defined(MIPS3)
+#if (MIPS3 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
 #define	USE_64BIT_INSTRUCTIONS
-#if defined(MIPS3_5900)		/* the 5900 has mips32-like mmu registers */
-#undef	USE_64BIT_CP0_FUNCTIONS
-#else
 #define	USE_64BIT_CP0_FUNCTIONS
-#endif
-#endif
-
-#if defined(MIPS32)
+#elif (MIPS32 + MIPS32R2) > 0
+#ifdef _LP64
+#error	MIPS32 and MIPS32R2 can't run 64-bit kernels.
+#endif
 #undef	USE_64BIT_INSTRUCTIONS
 #undef	USE_64BIT_CP0_FUNCTIONS
-#endif
-
-#if defined(MIPS64)
-#define	USE_64BIT_INSTRUCTIONS
-#define	USE_64BIT_CP0_FUNCTIONS
+#else
+#error	One of MIPS{3,32,32R2,64{,_RMIXL},64R2{,_RMIXL}} must be defined
 #endif
 
@@ -191,9 +182,15 @@
 #define	_SLL		dsll
 #define	_SRL		dsrl
+#define	_EXT		dext
+#define	_INS		dins
 #define	WIRED_SHIFT	34
+#define	WIRED_POS	30
 #else
 #define	_SLL		sll
 #define	_SRL		srl
+#define	_EXT		ext
+#define	_INS		ins
 #define	WIRED_SHIFT	2
+#define	WIRED_POS	30
 #endif
 
@@ -221,8 +218,19 @@
 #endif
 
+#if defined(MIPS32R2)
+	.set	mips32r2
+#endif
+
 #if defined(MIPS64)
 	.set	mips64
 #endif
 
+#if defined(MIPS64R2)
+	.set	mips64r2
+#endif
+
+#if defined(MIPS64_RMIXL) || defined(MIPS64R2_RMIXL)
+	.set	arch=xlr
+#endif
 
 /*
@@ -231,34 +239,29 @@
 
 #if defined(MIPS3)
-#ifdef __STDC__
-#define	MIPSX(name)	mips3_ ## name
-#else
-#define	MIPSX(name)	mips3_/**/name
-#endif
-#endif
-
-#if defined(MIPS3_5900)
-#undef MIPSX
-#ifdef __STDC__
-#define	MIPSX(name)	mips5900_ ## name
-#else
-#define	MIPSX(name)	mips5900_/**/name
-#endif
-#endif
-	
+#define	MIPSX(name)	__CONCAT(mips3_,name)
+#endif
+
 #if defined(MIPS32)
-#ifdef __STDC__
-#define	MIPSX(name)	mips32_ ## name
-#else
-#define	MIPSX(name)	mips32_/**/name
-#endif
+#define	MIPSX(name)	__CONCAT(mips32_,name)
+#endif
+
+#if defined(MIPS32R2)
+#define	MIPSX(name)	__CONCAT(mips32r2_,name)
 #endif
 
 #if defined(MIPS64)
-#ifdef __STDC__
-#define	MIPSX(name)	mips64_ ## name
-#else
-#define	MIPSX(name)	mips64_/**/name
-#endif
+#define	MIPSX(name)	__CONCAT(mips64_,name)
+#endif
+
+#if defined(MIPS64R2)
+#define	MIPSX(name)	__CONCAT(mips64r2_,name)
+#endif
+
+#if defined(MIPS64_RMIXL)
+#define	MIPSX(name)	__CONCAT(mips64_rmixl_,name)
+#endif
+
+#if defined(MIPS64R2_RMIXL)
+#define	MIPSX(name)	__CONCAT(mips64r2_rmixl_,name)
 #endif
 
@@ -280,9 +283,4 @@
  *	tlbp		-- one integer op afterwards
  * Obvious solution is to take least common denominator.
- *
- * For the Toshiba R5900, TX79:
- *	mtc0		following sync.p
- *	tlbw[ri], tlbp	following sync.p or eret
- * for those CPU, define COP0_SYNC as sync.p
  */
 
@@ -300,5 +298,5 @@
 
 /*
- * TLB handling data.   'CPUVAR(PMAP_SEGBASE)' points to the base of the segment
+ * TLB handling data.   'CPUVAR(PMAP_SEG0TAB)' points to the base of the segment
  * table.   this is read and written by C code in mips_machdep.c.
  *
@@ -333,5 +331,5 @@
  *----------------------------------------------------------------------------
  *
- * mips3_tlb_miss --
+ * mipsN_tlb_miss --
  *
  *	Vector code for the TLB-miss exception vector 0x80000000
@@ -348,41 +346,79 @@
 VECTOR(MIPSX(tlb_miss), unknown)
 	.set	noat
-	_MFC0	k0, MIPS_COP_0_BAD_VADDR	#00: k0=bad address
-	lui	k1, %hi(CPUVAR(PMAP_SEGBASE))	#01: k1=hi of segbase
-	bltz	k0, MIPSX(kernelfault)		#02: k0<0 -> 4f (kernel fault)
-	 PTR_SRL k0, (2*PGSHIFT-2-PTR_SCALESHIFT)#03: k0=seg offset (almost)
-	PTR_L	k1, %lo(CPUVAR(PMAP_SEGBASE))(k1)#04: k1=segment tab base
-	andi	k0, (NBPG-(1<<PTR_SCALESHIFT))	#05: k0=seg offset (mask 0x3)
-	PTR_ADDU k1, k0				#06: k1=seg entry address
-	PTR_L	k1, 0(k1)			#07: k1=seg entry
-	_MFC0	k0, MIPS_COP_0_BAD_VADDR	#08: k0=bad address (again)
-	beqz	k1, MIPSX(nopagetable)		#09: ==0 -- no page table
-	 PTR_SRL k0, (PGSHIFT-2)		#0a: k0=VPN (aka va>>10)
-	andi	k0, (NBPG-8)			#0b: k0=page tab offset
-	PTR_ADDU k1, k0				#0c: k1=pte address
-	INT_L	k0, 0(k1)			#0d: k0=lo0 pte
-	INT_L	k1, 4(k1)			#0e: k1=lo1 pte
-	_SLL	k0, WIRED_SHIFT			#0f: chop top 2 bits (part 1a)
-	_SRL	k0, WIRED_SHIFT			#10: chop top 2 bits (part 1b)
-#ifdef MIPS3_5900
-	_MTC0	k0, MIPS_COP_0_TLB_LO0		#11: lo0 is loaded
-	sync.p					#12: R5900 cop0 hazard
-	_SLL	k1, WIRED_SHIFT			#13: chop top 2 bits (part 2a)
-	_SRL	k1, WIRED_SHIFT			#14: chop top 2 bits (part 2b)
+#if defined(MULTIPROCESSOR) && (MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
+	_MFC0	k1, MIPS_COP_0_OSSCRATCH, 2	#00: get tlbinfo lock addr
+	li	k0, __SIMPLELOCK_LOCKED		#01: lock value
+	swapw	k0, k1				#02: swap it in place
+	bnez	k0, MIPSX(tlblocked)		#03: a lie
+						# lui in delay slot
+#endif
+	lui	k1, %hi(CPUVAR(PMAP_SEG0TAB))	#00: k1=hi of seg0tab
+	_MFC0	k0, MIPS_COP_0_BAD_VADDR	#01: k0=bad address
+	bltz	k0, MIPSX(kernelfault)		#02: k0<0 -> kernel fault
+	 PTR_SRL k0, 1*(PGSHIFT-PTR_SCALESHIFT)+(PGSHIFT-2)#03: k0=seg offset (almost)
+	PTR_L	k1, %lo(CPUVAR(PMAP_SEG0TAB))(k1)#04: k1=seg0tab
+MIPSX(tlb_miss_common):
+#ifdef _LP64
+	beqz	k1, MIPSX(nopagetable)		#05: is there a pagetable?
+	 nop					#06
+#endif
+	andi	k0, (NBPG-(1<<PTR_SCALESHIFT))	#07: k0=seg offset (mask 0x3)
+	PTR_ADDU k1, k0				#08: k1=seg entry address
+	PTR_L	k1, 0(k1)			#09: k1=seg entry
+	_MFC0	k0, MIPS_COP_0_BAD_VADDR	#0a: k0=bad address (again)
+#if (MIPS32R2 + MIPS64R2 + MIPS64R2_RMIXL) > 0
+	beqz	k1, MIPSX(nopagetable)		#0b: ==0 -- no page table
+	 _EXT	k0, k0, PGSHIFT+1, PGSHIFT-3	#0c: k0=VA[13:21]
+	_INS	k1, k0, 3, PGSHIFT-3		#0d: k0=page table index
+						#0d: k1=pte address
+#else
+	beqz	k1, MIPSX(nopagetable)		#0b: ==0 -- no page table
+	 PTR_SRL k0, (PGSHIFT-2)		#0c: k0=VPN (aka va>>10)
+	andi	k0, (NBPG-8)			#0d: k0=page table offset
+	PTR_ADDU k1, k0				#0e: k1=pte address
+#endif
+#if (MIPS64R2 + MIPS64R2_RMIXL) > 0
+	REG_L	k0, 0(k1)			#0f: load PTEs
+	_EXT	k1, k0, 32*_QUAD_HIGHWORD, WIRED_POS #10: extract lo1 pte
+	_EXT	k0, k0, 32*_QUAD_LOWWORD,  WIRED_POS #11: extract lo0 pte
+#elif (MIPS3 + MIPS64 + MIPS64_RMIXL) > 0
+	REG_L	k0, 0(k1)			#0f: load PTEs
+	_SLL	k1, k0, WIRED_SHIFT - 32*_QUAD_HIGHWORD #10: get lo1 pte
+	_SLL	k0, k0, WIRED_SHIFT - 32*_QUAD_LOWWORD  #11: get lo0 pte
+	_SRL	k0, WIRED_SHIFT			#12: chopped top 2 bits
+	_SRL	k1, WIRED_SHIFT			#13: chopped top 2 bits
+#elif (MIPS32 + MIPS32R2) > 0
+	INT_L	k0, 0(k1)			#0f: k0=lo0 pte
+	INT_L	k1, 4(k1)			#10: k1=lo1 pte
+#if (MIPS32R2) > 0
+	_EXT	k0, k0, 0, WIRED_POS		#11: chop top 2 bits
+	_EXT	k1, k1, 0, WIRED_POS		#12: chop top 2 bits
+#else
+	_SLL	k0, WIRED_SHIFT			#11: chop top 2 bits (part 1a)
+	_SLL	k1, WIRED_SHIFT			#11: chop top 2 bits (part 1a)
+	_SRL	k0, WIRED_SHIFT			#12: chop top 2 bits (part 1b)
+	_SRL	k1, WIRED_SHIFT			#13: chop top 2 bits (part 1b)
+#endif
+#else
+#error this shouldn't have happened
+#endif
+	_MTC0	k0, MIPS_COP_0_TLB_LO0		#14: lo0 is loaded
 	_MTC0	k1, MIPS_COP_0_TLB_LO1		#15: lo1 is loaded
-	sync.p					#16: R5900 cop0 hazard
-#else /* MIPS3_5900 */
-	_MTC0	k0, MIPS_COP_0_TLB_LO0		#11: lo0 is loaded
-	_SLL	k1, WIRED_SHIFT			#12: chop top 2 bits (part 2a)
-	_SRL	k1, WIRED_SHIFT			#13: chop top 2 bits (part 2b)
-	_MTC0	k1, MIPS_COP_0_TLB_LO1		#14: lo1 is loaded
-	nop					#15: standard nop
-	nop					#16: extra nop for QED5230
-#endif /* MIPS3_5900 */
-	tlbwr					#17: write to tlb
-	nop					#18: standard nop
-	nop					#19: needed by R4000/4400
-	nop					#1a: needed by R4000/4400
-	eret					#1b: return from exception
+	sll	$0, $0, 3			#16: standard nop (ehb)
+#ifdef MIPS3
+	nop					#17: extra nop for QED5230
+#endif
+	tlbwr					#18: write to tlb
+	sll	$0, $0, 3			#19: standard nop (ehb)
+#if defined(MULTIPROCESSOR) && (MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
+	_MFC0	k1, MIPS_COP_0_OSSCRATCH, 2	#1a get tlbinfo lock addr
+	INT_S	zero, 0(k1)			#1b clear lock
+#elif (MIPS3 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
+	lui	k1, %hi(CPUVAR(EV_TLBMISSES))	#1a: k1=hi of tlbmisses
+	REG_L	k0, %lo(CPUVAR(EV_TLBMISSES))(k1) #1b
+	REG_ADDU k0, 1				#1c
+	REG_S	k0, %lo(CPUVAR(EV_TLBMISSES))(k1) #1d
+#endif
+	eret					#1e: return from exception
 	.set	at
 _VECTOR_END(MIPSX(tlb_miss))
@@ -390,5 +426,5 @@
 #if defined(USE_64BIT_CP0_FUNCTIONS)
 /*
- * mips3_xtlb_miss routine
+ * mipsN_xtlb_miss routine
  *
  *	Vector code for the XTLB-miss exception vector 0x80000080 on an r4000.
@@ -406,32 +442,39 @@
 VECTOR(MIPSX(xtlb_miss), unknown)
 	.set	noat
+#if defined(MULTIPROCESSOR) && (MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
+	_MFC0	k1, MIPS_COP_0_OSSCRATCH, 2	# get tlbinfo lock addr
+	li	k0, __SIMPLELOCK_LOCKED		# try to lock it
+	swapw	k0, k1
+	bnez	k0, MIPSX(tlblocked)		# a lie
+	 nop
+#endif
 	dmfc0	k0, MIPS_COP_0_BAD_VADDR	#00: k0=bad address
-	lui	k1, %hi(CPUVAR(PMAP_SEGBASE))	#01: k1=hi of segbase
-	bltz	k0, MIPSX(kernelfault)		#02: k0<0 -> 4f (kernel fault)
-	 PTR_SRL k0, 2*PGSHIFT-2-PTR_SCALESHIFT	#03: k0=seg offset (almost)
-	PTR_L	k1, %lo(CPUVAR(PMAP_SEGBASE))(k1)#04: k1=segment tab base
-	andi	k0, NBPG-(1<<PTR_SCALESHIFT)	#05: k0=seg offset (mask 0x3)
-	PTR_ADDU k1, k0				#06: k1=seg entry address
-	PTR_L	k1, 0(k1)			#07: k1=seg entry
-	dmfc0	k0, MIPS_COP_0_BAD_VADDR	#08: k0=bad address (again)
-	beqz	k1, MIPSX(nopagetable)		#09: ==0 -- no page table
-	 PTR_SRL k0, (PGSHIFT-2)		#0a: k0=VPN (aka va>>10)
-	andi	k0, (NBPG-8)			#0b: k0=page tab offset
-	PTR_ADDU k1, k0				#0c: k1=pte address
-	INT_L	k0, 0(k1)			#0d: k0=lo0 pte
-	INT_L	k1, 4(k1)			#0e: k1=lo1 pte
-	_SLL	k0, WIRED_SHIFT			#0f: chop top 2 bits (part 1a)
-	_SRL	k0, WIRED_SHIFT			#10: chop top 2 bits (part 1b)
-	_MTC0	k0, MIPS_COP_0_TLB_LO0		#11: lo0 is loaded
-	_SLL	k1, WIRED_SHIFT			#12: chop top 2 bits (part 2a)
-	_SRL	k1, WIRED_SHIFT			#13: chop top 2 bits (part 2b)
-	_MTC0	k1, MIPS_COP_0_TLB_LO1		#14: lo1 is loaded
-	nop					#15: standard nop
-	nop					#16: extra nop for QED5230
-	tlbwr					#17: write to tlb
-	nop					#18: standard nop
-	nop					#19: needed by R4000/4400
-	nop					#1a: needed by R4000/4400
-	eret					#1b: return from exception
+#ifdef _LP64
+#ifdef MIPS3
+	nop					#01: nop
+#endif
+	bltz	k0, MIPSX(kernelfault)		#02: k0<0 -> kernel fault
+	 PTR_SRL k1,k0,2*(PGSHIFT-PTR_SCALESHIFT)+(PGSHIFT-2)+PGSHIFT #03: clear valid bits
+	bnez	k1, MIPSX(nopagetable)		#04: not legal address
+	 PTR_SRL k0, 2*(PGSHIFT-PTR_SCALESHIFT)+(PGSHIFT-2) #05: k0=seg offset (almost)
+	lui	k1, %hi(CPUVAR(PMAP_SEGTAB))	#06: k1=hi of segtab
+	andi	k0, NBPG-(1<<PTR_SCALESHIFT)	#07: k0=seg offset (mask 0x3)
+	PTR_L	k1, %lo(CPUVAR(PMAP_SEGTAB))(k1)#08: k1=segment tab
+	PTR_ADDU k1, k0				#09: k1=seg entry address
+	PTR_L	k1, 0(k1)			#0a: k1=seg entry
+#else
+	lui	k1, %hi(CPUVAR(PMAP_SEG0TAB))	#01: k1=hi of seg0tab
+	bltz	k0, MIPSX(kernelfault)		#02: k0<0 -> kernel fault
+	 dsrl	k0, 31				#03: clear low 31 bits
+	bnez	k0, MIPSX(nopagetable)		#04: not legal address
+	 nop
+	PTR_L	k1, %lo(CPUVAR(PMAP_SEG0TAB))(k1)#05: k1=segment tab base
+#endif /* _LP64 */
+	dmfc0	k0, MIPS_COP_0_BAD_VADDR	#0b: k0=bad address (again)
+#ifdef MIPS3
+	nop					#0c
+#endif
+	b	MIPSX(tlb_miss_common)		#0d
+	 PTR_SRL k0, 1*(PGSHIFT-PTR_SCALESHIFT)+(PGSHIFT-2) #0e: k0=seg offset (almost)
 	.set	at
 _VECTOR_END(MIPSX(xtlb_miss))
@@ -458,5 +501,5 @@
  *----------------------------------------------------------------------------
  *
- * mipsN_exception --
+ * mipsN_exception
  *
  *	Vector code for the general exception vector 0x80000180
@@ -486,10 +529,9 @@
 	PTR_LA	k0, MIPSX(excpt_sw)		#06: get base of the jump table
 	PTR_ADDU k0, k1				#08: get the address of the
-						#     function entry.  Note that
-						#     the cause is already
-						#     shifted left by 2 bits so
-						#     we dont have to shift.
+						#  function entry.  Note that
+						#  the cause is already
+						#  shifted left by 2 bits so
+						#  we dont have to shift.
 	PTR_L	k0, 0(k0)			#09: get the function address
-	#nop					#    -slip-
 #ifdef TSAR
 	mfc0	k1, MIPS_COP_0_TCCONTEXT, 5
@@ -510,13 +552,23 @@
 	.p2align 4
 MIPSX(kernelfault):
-	j	_C_LABEL(MIPSX(kernel_tlb_miss)) #10: kernel exception
+	j	_C_LABEL(MIPSX(kern_tlb_miss))	#10: kernel exception
 	 nop					#11: branch delay slot
 	nop
 	nop
 MIPSX(nopagetable):
-	lui	k1, %hi(CPUVAR(CURLWP))		#14: k1=hi of curlwp
-	j	MIPSX(slowfault)		#15: no page table present
-	 PTR_L	k1, %lo(CPUVAR(CURLWP))(k1)	#16: k1=lo of curlwp
-	nop					#17: branch delay slot
+#if defined(MULTIPROCESSOR) && (MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
+	_MFC0	k1, MIPS_COP_0_OSSCRATCH, 2	#14: get tlbinfo lock addr
+	 INT_S	zero, 0(k1)			#15: clear lock
+#endif
+	lui	k1, %hi(CPUVAR(CURLWP))		#16: k1=hi of curlwp
+	j	MIPSX(slowfault)		#17: no page table present
+	 PTR_L	k1, %lo(CPUVAR(CURLWP))(k1)	#18: k1=lo of curlwp
+	nop					#19: branch delay slot
+#if defined(MULTIPROCESSOR) && (MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
+MIPSX(tlblocked):
+	_MFC0	k1, MIPS_COP_0_OSSCRATCH, 0	#1a: k1=hi of curlwp
+	j	MIPSX(slowfault)		#1b: no page table present
+	 PTR_L	k1, CPU_INFO_CURLWP(k1)		#1c: k1=lo of curlwp
+#endif
 #endif
 	.set	at
@@ -551,8 +603,8 @@
 /*----------------------------------------------------------------------------
  *
- * MIPSX(slowfault) --
- *
- * Alternate entry point into the mips3_user_gen_exception or
- * mips3_kern_gen_exception, when the ULTB miss handler couldn't
+ * mipsN_slowfault
+ *
+ * Alternate entry point into the mipsN_user_gen_exception or
+ * mipsN_kern_gen_exception, when the UTLB miss handler couldn't
  * find a TLB entry.
  *
@@ -560,9 +612,4 @@
  *
  *----------------------------------------------------------------------------
- */
-
-/*
- * We couldn't find a TLB entry.
- * Find out what mode we came from and call the appropriate handler.
  */
 	.org	((. + 31) & ~31) + 12
@@ -571,22 +618,22 @@
 	mfc0	k0, MIPS_COP_0_STATUS
 	nop
-	and	k0, k0, MIPS3_SR_KSU_USER
+	and	k0, MIPS3_SR_KSU_USER
 	bnez	k0, _C_LABEL(MIPSX(user_gen_exception))
-	nop
+	 nop
 	.set	at
 /*
- * Fall though ...
- */
-
-/*
- * mips3_kern_gen_exception
- *
- * Handle an exception from kernel mode.
+ * Fall through ...
+ */
+
+/*
+ * mipsN_kern_gen_exception
+ *
+ * Handle an exception during kernel mode.
  * Build trapframe on stack to hold interrupted kernel context, then
  * call trap() to process the condition.
  *
- * trapframe is pointed to by the 5th arg
- * and a dummy sixth argument is used to avoid alignment problems
- *	{
+ * trapframe is pointed to by the 5th arg and a dummy sixth argument is used
+ * to avoid alignment problems
+ * {
  *	register_t cf_args[4 + 1];
  *	register_t cf_pad;		(for 8 word alignment)
@@ -600,11 +647,11 @@
 	.mask	0x80000000, -4
 #ifdef PARANOIA
-	PTR_L	k0, L_ADDR(k1)
-	slt	k0, k0, sp		# k0 = L_ADDR(k1) < sp
+	PTR_L	k0, L_PCB(MIPS_CURLWP)
+	slt	k0, k0, sp		# k0 = L_PCB(MIPS_CURLWP) < sp
 1:	beqz	k0, 1b			# loop forever if false
 	 nop
-	PTR_L	k0, L_ADDR(k1)
+	PTR_L	k0, L_PCB(MIPS_CURLWP)
 	PTR_ADDU k0, USPACE
-	slt	k0, sp, k0		# k0 = sp < L_ADDP(k1) + USPACE
+	slt	k0, sp, k0		# k0 = sp < L_PCB(MIPS_CURLWP) + USPACE
 2:	beqz	k0, 2b			# loop forever if false
 	 nop
@@ -615,5 +662,5 @@
  * the compiler does it for us.
  */
-	PTR_SUBU sp, sp, KERNFRAME_SIZ
+	PTR_SUBU sp, KERNFRAME_SIZ
 	REG_S	AT, TF_BASE+TF_REG_AST(sp)
 	REG_S	v0, TF_BASE+TF_REG_V0(sp)
@@ -636,5 +683,7 @@
 	REG_S	ta3, TF_BASE+TF_REG_TA3(sp)
 	_MFC0	a2, MIPS_COP_0_BAD_VADDR	# 3rd arg is fault address
-	REG_S	t8, TF_BASE+TF_REG_T8(sp)	# will be MIPS_CURLWP
+#ifdef DDB
+	REG_S	t8, TF_BASE+TF_REG_T8(sp)	# is MIPS_CURLWP
+#endif
 	REG_S	t9, TF_BASE+TF_REG_T9(sp)
 	REG_S	ra, TF_BASE+TF_REG_RA(sp)
@@ -644,4 +693,5 @@
 	REG_S	v1, TF_BASE+TF_REG_MULHI(sp)
 	REG_S	a3, TF_BASE+TF_REG_EPC(sp)
+	REG_S	a1, TF_BASE+TF_REG_CAUSE(sp)
 #if defined(DDB) || defined(KGDB)
 	REG_S	s0, TF_BASE+TF_REG_S0(sp)
@@ -683,6 +733,5 @@
 	 * Verify our existing interrupt level.
 	 */
-	PTR_L	t9, _C_LABEL(mips_splsw) + SPLSW_SPLCHECK
-	jalr	t9
+	jal	_C_LABEL(splcheck)
 	 nop
 #endif /* PARANOIA */
@@ -692,6 +741,6 @@
 	 * turn off interrupts in addition to clearing the exception level.
 	 */
-	li	v1, 1 << T_BREAK		# make a mask of T_BREAK
-	sll	t0, a1, MIPS_CR_EXC_CODE_SHIFT	# shift exc code to low 5 bits
+	li	v1, MIPS_SR_INT_IE << T_BREAK	# make a mask of T_BREAK
+	srl	t0, a1, MIPS_CR_EXC_CODE_SHIFT	# shift exc code to low 5 bits
 	srl	v1, t0				# shift break mask using it
 	and	v1, MIPS_SR_INT_IE		# restrict to IE bit
@@ -701,7 +750,5 @@
 	mtc0	v0, MIPS_COP_0_STATUS		# update.
 	COP0_SYNC
-	nop
-	nop
-	nop
+
 #ifdef TSAR
 	/* disable kernel preemption until we got data from the vcache */
@@ -712,37 +759,27 @@
 	 * Call the trap handler.
 	 */
-	jal	_C_LABEL(trap)			#
-	REG_S	a3, KERNFRAME_RA(sp)		# for debugging
-
-/*
- * Restore registers and return from the exception.
- */
+	jal	_C_LABEL(trap)
+	 REG_S	a3, KERNFRAME_RA(sp)		# for debugging
+
+	/*
+	 * Restore registers and return from the exception.
+	 */
 	RESET_EXCEPTION_LEVEL_DISABLE_INTERRUPTS(v0)
 	COP0_SYNC
-	nop					# 3 nop delay
-	nop
-	nop
+
 	REG_L	a0, TF_BASE+TF_REG_SR(sp)	# get SR with EXL set
+	mtc0	a0, MIPS_COP_0_STATUS		# restore the SR, disable intrs
+	COP0_SYNC
+
+	/*
+	 * Start of common kernel exception return code for both
+	 * mipxN_kern_gen_exception and mipsN_kern_intr.
+	 */
+MIPSX(kern_return):
 	REG_L	t0, TF_BASE+TF_REG_MULLO(sp)
 	REG_L	t1, TF_BASE+TF_REG_MULHI(sp)
 	REG_L	k1, TF_BASE+TF_REG_EPC(sp)	# might be changed inside trap
-	mtc0	a0, MIPS_COP_0_STATUS		# restore the SR, disable intrs
-	COP0_SYNC
 	mtlo	t0
 	mthi	t1
-
-#ifdef notyet
-	/* Check for restartable sequences. */
-	lui	t0, %hi(_C_LABEL(_lock_ras_start))
-	ori	t0, zero, %lo(_C_LABEL(_lock_ras_start))
-	li	t1, -MIPS_LOCK_RAS_SIZE
-	and	t1, t1, k1
-	bne	t1, t0, 3f
-	jal	_C_LABEL(_lock_ras)
-	nop
-#endif
-
-3:	_MTC0	k1, MIPS_COP_0_EXC_PC		# set return address
-	COP0_SYNC
 
 #ifdef PARANOIA
@@ -756,8 +793,22 @@
 	 * Verify our existing interrupt level.
 	 */
-	PTR_L	t9, _C_LABEL(mips_splsw) + SPLSW_SPLCHECK
-	jalr	t9
+	jal	_C_LABEL(splcheck)
 	 nop
 #endif /* PARANOIA */
+
+	/*
+	 * Check for kernel restartable atomic sequences.
+	 */
+	PTR_LA	t0, _C_LABEL(_lock_ras_start)
+	li	t1, -MIPS_LOCK_RAS_SIZE
+	and	t1, k1
+	bne	t1, t0, 1f			# exception PC in RAS area?
+	 nop
+	jal	_C_LABEL(_restart_lock_ras)	# fix the pc (k1)
+	 nop
+1:
+
+	_MTC0	k1, MIPS_COP_0_EXC_PC		# set return address
+	COP0_SYNC
 
 	REG_L	AT, TF_BASE+TF_REG_AST(sp)
@@ -776,5 +827,5 @@
 	REG_L	ta2, TF_BASE+TF_REG_TA2(sp)
 	REG_L	ta3, TF_BASE+TF_REG_TA3(sp)
-	REG_L	t8, TF_BASE+TF_REG_T8(sp)	# was MIPS_CURLWP
+	#REG_L	t8, TF_BASE+TF_REG_T8(sp)	# is MIPS_CURLWP
 	REG_L	t9, TF_BASE+TF_REG_T9(sp)
 	REG_L	ra, TF_BASE+TF_REG_RA(sp)
@@ -790,5 +841,5 @@
 	REG_L	s8, TF_BASE+TF_REG_S8(sp)
 #endif
-	PTR_ADDU sp, sp, KERNFRAME_SIZ
+	PTR_ADDU sp, KERNFRAME_SIZ
 	eret					# return to interrupted point
 	.set	at
@@ -796,7 +847,285 @@
 
 /*
+ * mipsN_kern_intr
+ *
+ * Handle an interrupt from kernel mode.
+ * Build kernframe on stack to hold interrupted kernel context, then
+ * call cpu_intr() to process it.
+ *
+ */
+	.p2align 5
+NESTED_NOPROFILE(MIPSX(kern_intr), KERNFRAME_SIZ, ra)
+	.set	noat
+	.mask	0x80000000, -4
+#ifdef PARANOIA
+	PTR_L	k0, L_PCB(MIPS_CURLWP)
+	slt	k0, k0, sp			# k0 = L_PCB(MIPS_CURLWP) < sp
+1:	beqz	k0, 1b				# loop forever if false
+	 nop
+	PTR_L	k0, L_PCB(MIPS_CURLWP)
+	PTR_ADDU k0, USPACE
+	slt	k0, sp, k0			# k0 = sp < L_PCB(MIPS_CURLWP) + USPACE
+2:	beqz	k0, 2b				# loop forever if false
+	 nop
+	PTR_L	k0, L_CPU(MIPS_CURLWP)
+	INT_L	k0, CPU_INFO_IDEPTH(k0)		# grab interrupt depth
+	sltu	k0, k0, 3			# must be < 3
+3:	beqz	k0, 3b				# loop forever if false
+	 nop
+#endif
+	/*
+	 * Save the relevant kernel registers onto the stack.  We don't need
+	 * to save s0 - s8, sp, and gp because the compiler does it for us.
+	 * But we use s0-s2 so need to save them.
+	 */
+	PTR_SUBU sp, KERNFRAME_SIZ
+	REG_S	AT, TF_BASE+TF_REG_AST(sp)
+	REG_S	v0, TF_BASE+TF_REG_V0(sp)
+	REG_S	v1, TF_BASE+TF_REG_V1(sp)
+	mflo	v0
+	mfhi	v1
+	REG_S	a0, TF_BASE+TF_REG_A0(sp)
+	REG_S	a1, TF_BASE+TF_REG_A1(sp)
+	REG_S	a2, TF_BASE+TF_REG_A2(sp)
+	REG_S	a3, TF_BASE+TF_REG_A3(sp)
+	REG_S	t0, TF_BASE+TF_REG_T0(sp)
+	REG_S	t1, TF_BASE+TF_REG_T1(sp)
+	REG_S	t2, TF_BASE+TF_REG_T2(sp)
+	REG_S	t3, TF_BASE+TF_REG_T3(sp)
+	REG_S	ta0, TF_BASE+TF_REG_TA0(sp)
+	REG_S	ta1, TF_BASE+TF_REG_TA1(sp)
+	REG_S	ta2, TF_BASE+TF_REG_TA2(sp)
+	REG_S	ta3, TF_BASE+TF_REG_TA3(sp)
+	REG_S	s0, TF_BASE+TF_REG_S0(sp)	# used for saved ipl/idepth
+	REG_S	s1, TF_BASE+TF_REG_S1(sp)	# used for initial status
+	mfc0	s1, MIPS_COP_0_STATUS
+	REG_S	s2, TF_BASE+TF_REG_S2(sp)	# used for cpu_info
+#ifdef DDB
+	REG_S	t8, TF_BASE+TF_REG_T8(sp)	# already contains MIPS_CURLWP
+#endif
+	REG_S	t9, TF_BASE+TF_REG_T9(sp)
+	REG_S	ra, TF_BASE+TF_REG_RA(sp)
+	REG_S	s1, TF_BASE+TF_REG_SR(sp)
+	REG_S	v0, TF_BASE+TF_REG_MULLO(sp)
+	REG_S	v1, TF_BASE+TF_REG_MULHI(sp)
+/*
+ * Call the interrupt handler.
+ */
+	_MFC0	ta0, MIPS_COP_0_EXC_PC		# grab exception PC
+	PTR_L	s2, L_CPU(MIPS_CURLWP)		# delay slot
+	REG_S	ta0, TF_BASE+TF_REG_EPC(sp)	# and save it
+
+#if defined(DDB) || defined(DEBUG) || defined(KGDB)
+	REG_S	ta0, KERNFRAME_RA(sp)		# for debugging
+#endif
+
+#ifdef PARANOIA
+	INT_L	s0, CPU_INFO_CPL(s2)
+	INT_S	s0, TF_BASE+TF_PPL(sp)		# save priority level
+
+	/*
+	 * Verify the current interrupt level
+	 */
+	jal	_C_LABEL(splcheck)
+	 nop
+#endif /* PARANOIA */
+
+	/*
+	 * We first need to get to IPL_HIGH so that interrupts are masked.
+	 */
+	jal	_C_LABEL(splhigh_noprof)
+	 nop
+
+#ifdef PARANOIA
+1:	bne	s0, v0, 1b
+	 nop
+#endif /* PARANOIA */
+
+	sll	s0, v0, 8			# remember previous priority
+						# low 8 bits used for idepth
+
+#ifdef PARANOIA
+	/*
+	 * Interrupts at IPL_HIGH are not allowed.
+	 */
+	li	v1, IPL_HIGH
+	sltu	t0, v0, v1
+2:	beqz	t0, 2b
+	 nop
+#endif /* PARANOIA */
+
+	INT_L	t1, CPU_INFO_IDEPTH(s2)		# we need to inc. intr depth
+	or	s0, t1				#   save old interrupt depth
+	INT_ADDU t1, 1
+	INT_S	t1, CPU_INFO_IDEPTH(s2)		#   store new interrupt depth
+
+	/*
+	 * Now we can clear exception level since no interrupts can be delivered
+	 */
+	mfc0	v1, MIPS_COP_0_STATUS
+	and	v0, v1, MIPS_SR_EXL		# grab exception level bit
+	xor	v0, v1				# clear it
+	mtc0	v0, MIPS_COP_0_STATUS		# write new status
+	COP0_SYNC
+
+	/*
+	 * Now hard interrupts can be processed.
+	 */
+	move	a1, ta0				# 2nd arg is exception PC
+	move	a2, s1				# 3rd arg is status
+	jal	_C_LABEL(cpu_intr)		# cpu_intr(ppl, pc, status)
+	 srl	a0, s0, 8			# 1st arg is previous pri level
+
+	and	t1, s0, 0xff			# get previous interrupt depth
+	INT_S	t1, CPU_INFO_IDEPTH(s2)		# to it previous value
+
+#ifdef PARANOIA
+	mfc0	t0, MIPS_COP_0_STATUS		# verify INT_IE is still set
+	and	t0, MIPS_SR_INT_IE
+3:	beqz	t0, 3b
+	 nop
+#endif /* PARANOIA */
+
+#ifdef __HAVE_FAST_SOFTINTS
+	and	a0, s1, MIPS_SOFT_INT_MASK	# were softints enabled?
+	beqz	a0, 4f				#   nope
+	 nop
+	mfc0	v0, MIPS_COP_0_CAUSE		# grab the pending softints
+	and	a0, v0				# are softints pending
+	beqz	a0, 4f				#   nope
+	 nop
+
+	jal	_C_LABEL(softint_process)	# softint_process(pending)
+	 nop
+
+#ifdef __HAVE_PREEMPTION
+	srl	v1, s0, 8			# get saved priority level
+	bnez	v1, 4f				# branch if not at IPL_NONE
+	 nop
+	INT_L	t0, CPU_INFO_SOFTINTS(s2)	# get pending softints
+	and	v0, t0, 1 << SOFTINT_KPREEMPT	# do we need a kernel preempt?
+	beqz	v0, 4f				#   nope
+	 nop
+	xor	t0, v0				# clear preempt bit
+	INT_S	t0, CPU_INFO_SOFTINTS(s2)	# and save it.
+
+	jal	_C_LABEL(splx_noprof)		# drop to IPL_SCHED
+	 li	a0, IPL_SCHED
+
+	jal	_C_LABEL(kpreempt)		# kpreempt(pc)
+	 li	a0, -2
+#endif /* __HAVE_PREEMPTION */
+4:
+#endif /* __HAVE_FAST_SOFTINT */
+	/*
+	 * Interrupts handled, restore registers and return from the interrupt.
+	 * First, clear interrupt enable
+	 */
+	mfc0	v0, MIPS_COP_0_STATUS		# read it 
+	xor	v0, MIPS_SR_INT_IE		# disable interrupts
+	mtc0	v0, MIPS_COP_0_STATUS		# write it
+	COP0_SYNC
+
+	or	v0, MIPS_SR_EXL			# set exception mode
+	mtc0	v0, MIPS_COP_0_STATUS		# write it
+	COP0_SYNC
+
+	srl	a0, s0, 8			# get previous priority level
+#ifdef PARANOIA
+	INT_L	t0, TF_BASE+TF_PPL(sp)		# get saved priority level
+9:	bne	t0, a0, 9b			# should still match
+	 nop
+
+	li	t0, IPL_HIGH
+	sltu	v0, a0, t0
+8:	beqz	v0, 8b
+	 nop
+#endif /* PARANOIA */
+
+	/*
+	 * Restore IPL knowing interrupts are disabled
+	 */
+	jal	_C_LABEL(splx_noprof)		# splx(ppl)
+	 nop
+
+#ifdef PARANOIA
+	mfc0	v0, MIPS_COP_0_STATUS
+	or	v0, MIPS_SR_INT_IE
+5:	bne	v0, s1, 5b
+	 nop
+#endif /* PARANOIA */
+
+	/*
+	 * Restore SR
+	 */
+	mtc0	s1, MIPS_COP_0_STATUS
+	COP0_SYNC
+
+	/*
+	 * Restore s0-s2 and goto common kernel return code.
+	 */
+	REG_L	s0, TF_BASE+TF_REG_S0(sp)
+	REG_L	s1, TF_BASE+TF_REG_S1(sp)
+	b	MIPSX(kern_return)
+	 REG_L	s2, TF_BASE+TF_REG_S2(sp)
+	.set	at
+END(MIPSX(kern_intr))
+
+/*
+ *
+ */
+	.p2align 5
+NESTED_NOPROFILE(MIPSX(user_reserved_insn), CALLFRAME_SIZ, ra)
+	.set	noat
+	.mask	0x80000000, -4
+	/*
+	 * Save a minimum of registers to see if this is rdhwr $3,$29
+	 */
+	/* K1 already has CURLWP */
+	PTR_L	k0, L_PCB(k1)			# XXXuvm_lwp_getuarea
+	PTR_ADDU k0, USPACE - TF_SIZ - CALLFRAME_SIZ
+
+	/* Need two working registers */
+	REG_S	AT, CALLFRAME_SIZ+TF_REG_AST(k0)
+	REG_S	v0, CALLFRAME_SIZ+TF_REG_V0(k0)
+
+	/* If this was in a branch delay slot, take the slow path. */
+	mfc0	v0, MIPS_COP_0_CAUSE
+	bltz	v0, MIPSX(user_gen_exception_common)
+	 nop
+
+	/*
+	 * Get exception PC and fetch the instruction.  We know we can do
+	 * this since the instruction actually got read.
+	 */
+	_MFC0	v0, MIPS_COP_0_EXC_PC
+	INT_L	AT, 0(v0)
+
+	/*
+	 * Was this rdhwr $3,$29?
+	 */
+	lui	v0, %hi(0x7c03e83b)
+	addiu	v0, %lo(0x7c03e83b)
+	bne	AT, v0, MIPSX(user_gen_exception_common)
+	 nop
+
+	/*
+	 * Advance the PC (don't want to restart at the rdhwr).
+	 */
+	_MFC0	v0, MIPS_COP_0_EXC_PC
+	PTR_ADDIU v0, 4
+	_MTC0	v0, MIPS_COP_0_EXC_PC
+
+	PTR_L	v1, L_PRIVATE(k1)		# rdhwr $3,$29 updates v1
+	REG_L	AT, CALLFRAME_SIZ+TF_REG_AST(k0)# restore reg
+	REG_L	v0, CALLFRAME_SIZ+TF_REG_V0(k0) # restore reg
+	sll	$0,$0,3				# just in case
+	eret
+END(MIPSX(user_reserved_insn))
+
+/*
  * mipsN_user_gen_exception
  *
- * Handle an exception from user mode.
+ * Handle an exception during user mode.
  * Save user context atop the kernel stack, then call trap() to process
  * the condition.  The context can be manipulated alternatively via
@@ -807,12 +1136,13 @@
 	.set	noat
 	.mask	0x80000000, -4
-/*
- * Save all of the registers except for the kernel temporaries in u_pcb.
- */
+	/*
+	 * Save all the registers except the kernel temporaries onto the stack.
+	 */
 	/* K1 already has CURLWP */
-	PTR_L	k0, L_ADDR(k1)
-	PTR_ADDU k0, k0, USPACE - TF_SIZ - CALLFRAME_SIZ
+	PTR_L	k0, L_PCB(k1)			# XXXuvm_lwp_getuarea
+	PTR_ADDU k0, USPACE - TF_SIZ - CALLFRAME_SIZ
 	REG_S	AT, CALLFRAME_SIZ+TF_REG_AST(k0)
 	REG_S	v0, CALLFRAME_SIZ+TF_REG_V0(k0)
+MIPSX(user_gen_exception_common):
 	REG_S	v1, CALLFRAME_SIZ+TF_REG_V1(k0)
 	mflo	v0
@@ -855,10 +1185,10 @@
 	PTR_LA	gp, _C_LABEL(_gp)		# switch to kernel GP
 #endif
-	move	sp, k0
+	move	sp, k0				# switch to kernel SP
 	move	MIPS_CURLWP, k1
 #ifdef TSAR
 	/* disable kernel preemption until we got data from the vcache */
 	jal	_C_LABEL(kpreempt_disable)
-	nop
+	 nop
 #endif
 #ifdef NOFPU
@@ -873,5 +1203,5 @@
 	 */
 	lui	t0, %hi(~(MIPS_SR_COP_1_BIT|MIPS_SR_EXL|MIPS_SR_KSU_MASK))
-	ori	t0, %lo(~(MIPS_SR_COP_1_BIT|MIPS_SR_EXL|MIPS_SR_KSU_MASK))
+	addiu	t0, %lo(~(MIPS_SR_COP_1_BIT|MIPS_SR_EXL|MIPS_SR_KSU_MASK))
 	and	t0, a0
 #endif
